// TauDEM.cpp : Implementation of CTauDEM
#include "stdafx.h"
#include "TkTauDEM.h"
#include "TauDEM.h"
#include "TDErrorCodes.h"

/////////////////////////////////////////////////////////////////////////////
// CTauDEM

STDMETHODIMP CTauDEM::Flood(BSTR demfile, BSTR fillfile, BSTR fdrfile, BSTR fdrnfile, 
							  short useflowfile, VARIANT_BOOL InRam, long *result)
{
	USES_CONVERSION; //needed to convert from BSTR to Char* or CString
	// BSTR is a string from VB that is first the number of characters followed by data
	// OLE2A converts this to a regular C character pointer 'char *'
	// To return to VB use A2BSTR

	bool MemoryBased;

	if (InRam == FALSE)
		MemoryBased = false;
	else
		MemoryBased = true;

	*result = flood( OLE2A(demfile), OLE2A(fillfile), OLE2A(fdrfile), useflowfile, 
		OLE2A(fdrnfile),MemoryBased );
	return S_OK;
}

STDMETHODIMP CTauDEM::D8(BSTR felfile, BSTR pfile, BSTR sd8file, BSTR fdrnfile, 
						   short useflowfile, VARIANT_BOOL InRam, long *result)
{
	USES_CONVERSION; //needed to convert from BSTR to Char* or CString

	bool MemoryBased;

	if (InRam == FALSE)
		MemoryBased = false;
	else
		MemoryBased = true;

	*result = setdird8( OLE2A(felfile), OLE2A(pfile), OLE2A(sd8file), OLE2A(fdrnfile),
		useflowfile, MemoryBased);
	return S_OK;
}



STDMETHODIMP CTauDEM::Dinf(BSTR felfile, BSTR angfile, BSTR slopefile, BSTR fdrnfile, 
							 short useflowfile,VARIANT_BOOL InRam, long *result)
{
	USES_CONVERSION; //needed to convert from BSTR to Char* or CString

	bool MemoryBased;

	if (InRam == FALSE)
		MemoryBased = false;
	else
		MemoryBased = true;

	*result = setdir( OLE2A(felfile), OLE2A(angfile), OLE2A(slopefile), OLE2A(fdrnfile),
		useflowfile, MemoryBased);
	return S_OK;
}

STDMETHODIMP CTauDEM::Aread8(BSTR pfile, BSTR ad8file, double * x, double * y, long nxy, long doall, 
							   BSTR wfile, long usew, long contcheck, long *result)
{
	USES_CONVERSION; //needed to convert from BSTR to Char* or CString
	*result = aread8( OLE2A(pfile), OLE2A(ad8file), x,y,nxy,doall, OLE2A(wfile),
		usew, contcheck);

	return S_OK;
}

STDMETHODIMP CTauDEM::Areadinf(BSTR angfile, BSTR scafile, double *x, double *y, long nxy, int doall,
								 BSTR wfile, int usew, int contcheck, long *result)
{
	USES_CONVERSION; //needed to convert from BSTR to Char* or CString
	*result = area( OLE2A(angfile), OLE2A(scafile), x,y,nxy,doall, OLE2A(wfile),
		usew, contcheck);

	return S_OK;
}

STDMETHODIMP CTauDEM::Gridnet(BSTR pfile, BSTR plenfile, BSTR tlenfile, BSTR gordfile,
		BSTR maskfile, double *x, double *y, long xyCount, long UseMaskFile, long UseOutlets, long thresh, long *result)
{
	USES_CONVERSION; //needed to convert from BSTR to Char* or CString
	*result = gridnet( OLE2A(pfile), OLE2A(plenfile), OLE2A(tlenfile), OLE2A(gordfile), 
		OLE2A(maskfile),x,y,xyCount,UseMaskFile,UseOutlets,thresh);
	return S_OK;
}

STDMETHODIMP CTauDEM::Sourcedef(BSTR ad8file, BSTR slpfile, BSTR plenfile, 
				BSTR pfile, BSTR srcfile, BSTR elevfile, BSTR gordfile, BSTR scafile, 
				BSTR fdrnfile, int method, float *p, int nxy, double *x, double *y, 
				int contcheck, int masksca, long *result)
{
	USES_CONVERSION; //needed to convert from BSTR to Char* or CString
	*result = source(OLE2A(ad8file), OLE2A(slpfile), OLE2A(plenfile), OLE2A(pfile),
		   OLE2A(srcfile), OLE2A(elevfile), OLE2A(gordfile), OLE2A(scafile),
		   OLE2A(fdrnfile), method, p, nxy, x, y, contcheck,0,masksca);
	return S_OK;
}

STDMETHODIMP CTauDEM::Netsetup(BSTR fnprefix, BSTR pfile, BSTR srcfile, BSTR ordfile,
								 BSTR ad8file, BSTR felfile, BSTR treefile, 
								 BSTR coordfile, double *xnode, 
								 double *ynode, int nxy, long usetrace, long *idnodes, long *result)
{
	USES_CONVERSION; //needed to convert from BSTR to Char* or CString
	*result = netsetup(OLE2A( fnprefix), OLE2A( pfile), OLE2A( srcfile), OLE2A( ordfile),
								 OLE2A( ad8file), OLE2A( felfile), OLE2A( treefile), 
								 OLE2A( coordfile),xnode, ynode, nxy, usetrace, idnodes);
	return S_OK;
}

STDMETHODIMP CTauDEM::Subbasinsetup(BSTR pfile, BSTR wfile, BSTR treefile, 
									  BSTR coordfile, BSTR shapefile, int ordert, 
									  int subbno, long *result)
{
	USES_CONVERSION; //needed to convert from BSTR to Char* or CString
	*result=subbasinsetup(OLE2A(pfile),OLE2A(wfile),OLE2A(treefile),OLE2A(coordfile),
						  OLE2A(shapefile),ordert,subbno);

	return S_OK;
}

STDMETHODIMP CTauDEM::Dropan(BSTR areafile, BSTR slopefile, BSTR plenfile, BSTR dirfile, 
							   BSTR srcfile, BSTR elevfile, BSTR gordfile, BSTR scafile, 
							   BSTR fdrfile, int method, float *p, int nxy, double *x, 
							   double *y, int contcheck, int nthresh, int *thresholds, 
							   int *nfirstorder, int *nhigherorder, float *sumfirstorder, 
							   float *sumhigherorder, float *sumfirstordersquared, 
							   float *sumhigherordersquared, float *ddens, long masksca, long *result)
{
	
		USES_CONVERSION; //needed to convert from BSTR to Char* or CString
		*result = dropan(OLE2A(areafile), OLE2A(slopefile), OLE2A(plenfile), OLE2A(dirfile), 
		   OLE2A(srcfile), OLE2A(elevfile), OLE2A(gordfile), OLE2A(scafile),
		   OLE2A(fdrfile), method, p, nxy, x, y, 
		   contcheck,nthresh,thresholds, nfirstorder, nhigherorder,
		   sumfirstorder, sumhigherorder, sumfirstordersquared, sumhigherordersquared, 
		   ddens, masksca);
	return S_OK;
}



STDMETHODIMP CTauDEM::StreamToGrid(BSTR Shapefilename,BSTR Gridfilename, BSTR TemplateDEMfile, BOOL * result)
{	

	return 1;
}


STDMETHODIMP CTauDEM::WatershedToPolygon(BSTR WGridFile, BSTR PGridFile, BSTR ShapefileName, long *result)
{

	return 1;
}

STDMETHODIMP CTauDEM::Atanb(BSTR slopefile, BSTR areafile, BSTR atanbfile, int diskbasedflag,long *ans)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	USES_CONVERSION; //needed to convert from BSTR to Char* or CString
	*ans = atanbgrid(OLE2A(slopefile), OLE2A(areafile), OLE2A(atanbfile), diskbasedflag);
	return S_OK;
}

STDMETHODIMP CTauDEM::Distance(BSTR pfile, BSTR srcfile, BSTR distfile, int thresh, int diskbasedflag, long *result)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	USES_CONVERSION; //needed to convert from BSTR to Char* or CString
	*result = distgrid(OLE2A(pfile), OLE2A(srcfile), OLE2A(distfile), thresh, diskbasedflag);
	return S_OK;
}


STDMETHODIMP CTauDEM::AreadinfDecay(BSTR angfile, BSTR adecfile, BSTR dmfile, double *x, double *y, long nxy, 
									  BSTR wfile, long usew, long contcheck, long *result)
{
	
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	USES_CONVERSION;
	

	*result = dmarea(OLE2A(angfile),OLE2A(adecfile),OLE2A(dmfile),x,y,nxy,OLE2A(wfile),usew,contcheck);

	return S_OK;
}

STDMETHODIMP CTauDEM::DsAccum(BSTR angfile, BSTR wgfile, BSTR depfile, BSTR maxfile, long touch, float wgval, long *result)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	
	USES_CONVERSION;

	*result = dsaccum(OLE2A(angfile),OLE2A(wgfile), OLE2A(depfile),OLE2A(maxfile),touch,wgval);

	return S_OK;
}

STDMETHODIMP CTauDEM::TlAccum(BSTR pfile, BSTR wfile, BSTR tcfile, BSTR tlafile, BSTR depfile, 
			BSTR cfile, BSTR coutfile, double *x, double *y, long nxy,   long usec, long contcheck, long *result)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	USES_CONVERSION;
	
	*result = tlaccum(OLE2A(pfile),OLE2A(wfile),OLE2A(tcfile),OLE2A(tlafile),OLE2A(depfile),OLE2A(cfile),
						OLE2A(coutfile),x,y,nxy,usec,contcheck,GlobalCallback);

	return S_OK;
}

STDMETHODIMP CTauDEM::get_Callback(ItkCallback **pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	*pVal = GlobalCallback;
	if (GlobalCallback)
		GlobalCallback->AddRef(); //add a reference, the recipient is responsible for releasing it when done.

	return S_OK;
}

STDMETHODIMP CTauDEM::put_Callback(ItkCallback *newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	GlobalCallback = newVal;

	if (GlobalCallback)
		GlobalCallback->AddRef(); //add a reference to count since we are storing this pointer, we release in destructor

	return S_OK;
}

STDMETHODIMP CTauDEM::SLLAccum(BSTR pfile, BSTR outputFile, BSTR decayMultFile, double *x, double *y, long nxy, BSTR wFile, BSTR indicatorFile, long contcheck, float cSol, long *result)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	USES_CONVERSION;
	*result = dsllArea(OLE2A(pfile), OLE2A(outputFile), OLE2A(decayMultFile), x,y,nxy,OLE2A(wFile), OLE2A(indicatorFile),contcheck,cSol, GlobalCallback);

	return S_OK;
}

STDMETHODIMP CTauDEM::Dependence(BSTR anglefile, BSTR disturbgridfile, BSTR depfile, long *result)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	USES_CONVERSION;
	*result = depgrd(OLE2A(anglefile),OLE2A(disturbgridfile),OLE2A(depfile));

	return S_OK;
}

STDMETHODIMP CTauDEM::getErrorMsg(long errorNumber, BSTR *retval)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	CString msg;

	/*
		see TDErrorCodes.h
	 TD_NO_ERROR					0
	 TD_FAILED_GRID_OPEN			1
	 TD_FAILED_GRID_SAVE			2
	 TD_FAILED_MEMORY_ALLOC			3
	 TD_STACK_LARGER_THAN_GRID		4
	 TD_FAILED_TO_ENLARGE_STACK		5
	 TD_DROPAN_ENCOUNTERED_ZERO		6
	 TD_COORDINATE_OUTSIDE_GRID		7
	 TD_CHANNEL_NETWORK_MISMATCH	8
	 TD_FAILED_TREEFILE_OPEN		9
	 TD_FAILED_COORDFILE_OPEN		10
	 TD_NEGATIVE_SA_VALUE			11
	 TD_NEGATIVE_OVERLAND_DIST		12
	 TD_INVALID_TABLE_INDEX			13
	 TD_INVALID_TABLE_ROW_INDEX		14
	 TD_TABLE_ROW_MISSING_PARAM		15
	 TD_INVALID_TABLE_COL_INDEX		16
	 TD_PARAM_GRID_NO_DATA			17
	 TD_FAILED_WTR_SHED_GRD_OPEN	18
	 TD_FAILED_CONNECT_GRD_OPEN		19
	 TD_FAILED_CREATE_SHP_FILE		20
	 TD_INVALID_RAINFALL_SHPFILE	21
	 TD_PARAM_COUNT_INCONSISTENT	22
	 TD_INVALID_VARIANT_TYPE		23
	 TD_UNEXPECTED_NODATA_IN_GRD	24
	 TD_FAILED_SAVE_SHPFILE			25
	 TD_FAILED_GRD_INIT				26
	 TD_GRID_SIZE_MISMATCH			27
	 TD_FAILED_SHPFILE_OPEN			28
	 TD_FAILED_GET_HEADER			29
	 TD_INVALID_ARRAY_SIZE			30
	 TD_FAILED_FILE_OPEN			31
	*/
	switch(errorNumber)
	{
		case TD_NO_ERROR:
			msg = "No Error";
			break;
		case TD_FAILED_GRID_OPEN:
			msg = "Unable to open grid for reading. (Common causes:  Spaces in file path, file does not exist, file is corrupt or in use, file data type mismatch or insufficient memory - likely as grids get larger than 7000 rows x 7000 columns)";
			break;
		case TD_FAILED_GRID_SAVE:
			msg = "Unable to open grid file for writing. (Common causes:  Spaces in file path, name too long, may be trying to overwrite existing file that is locked or protected)";
			break;
		case TD_FAILED_MEMORY_ALLOC: 
			msg = "Memory allocation error.  (Problem possibly too large to handle - or out of disk or swap space - likely as grids get larger than 7000 rows x 7000 columns)";
			break;
		case TD_STACK_LARGER_THAN_GRID:
			msg = "Stack in pit removal bigger than grid.  (Problem may be too large to handle)";
			break;
		case TD_FAILED_TO_ENLARGE_STACK:
			msg = "Memory allocation error when enlarging stack. (Problem possibly too large to handle - or out of disk or swap space)";
			break;
		case TD_DROPAN_ENCOUNTERED_ZERO:
			msg = "Drop Analysis encounterd zero drainage area. Check specification of outlets.";
			break;
		case TD_COORDINATE_OUTSIDE_GRID:
			 msg = "Logic error or markbasin encountered coordinate outside grid";
			 break;
		case TD_CHANNEL_NETWORK_MISMATCH:
			msg = "In calculating channel network raster the specified outlets did not match with channel grid cells.  Check location of outlets or the channel delineation method.";
			break;
		case TD_FAILED_TREEFILE_OPEN:
			msg = "Unable to open treefile (Probably not present)";
			break;
		case TD_FAILED_COORDFILE_OPEN:
			msg = "Unable to open coordfile (Probably not present)";
			break;
		case TD_NEGATIVE_SA_VALUE:
			msg = "Non positive S/a value encountered";
			break;
		case TD_NEGATIVE_OVERLAND_DIST:
			msg = "Negative overland flow distance encountered";
			break;
		case TD_INVALID_TABLE_INDEX:
			msg = "Attempted to reference a table with index higher than number of tables";
			break;
		case TD_INVALID_TABLE_ROW_INDEX:
			msg = "Record (row) in table lookup out of range";
			break;
		case TD_TABLE_ROW_MISSING_PARAM: 
			msg = "Record (row) in table lookup does not have parameter values";
			break;
		case TD_INVALID_TABLE_COL_INDEX:
			msg = "Field (column) in table lookup out of range";
			break;
		case TD_PARAM_GRID_NO_DATA:
			msg = "Parameter grid has no data at all for a subwatershed";
			break;
		case TD_FAILED_WTR_SHED_GRD_OPEN:
			msg = "Unable to open Watershed Grid";
			break;
		case TD_FAILED_CONNECT_GRD_OPEN:
			msg = "Unable to open Connection Grid";
			break;
		case TD_FAILED_CREATE_SHP_FILE:
			msg = "Failed to create Watershed polygon shapefile";
			break;
		case TD_INVALID_RAINFALL_SHPFILE:
			msg = "An invalid rainfall shapefile was chosen for the topsetup routine. This may occur if your shapefile database doesn't contain an 'ID' field. Also, make sure that the shapefile is a point shapefile, not a polygon shapefile.";
			break;
		case TD_PARAM_COUNT_INCONSISTENT:
			msg = "Inconcistency between the number of tables and the number of lookup grids in call to TopSetup";
			break;
		case TD_INVALID_VARIANT_TYPE:
			msg = "Topsetup called with incorrect variant type for file name list";
			break;
		case TD_UNEXPECTED_NODATA_IN_GRD:
			msg = "Unexpected 'No Data Value' found in grid.";
			break;
		case TD_FAILED_SAVE_SHPFILE:
			msg = "Failed to save shapefile.  File may already exist.";
			break;
		case TD_FAILED_GRD_INIT:
			msg = "Failed to initialize new grid.";
			break;
		case TD_GRID_SIZE_MISMATCH:
			msg = "Input grids differ in size.";
			break;
		case TD_FAILED_SHPFILE_OPEN:
			msg = "Failed to open shapefile.";
			break;
		case TD_FAILED_GET_HEADER:
			msg = "Failed to get grid info header.";
			break;
		case TD_INVALID_ARRAY_SIZE:
			msg = "Calculated array size and parameter array sizes don't match.";
			break;
		case TD_FAILED_FILE_OPEN:
			msg = "Failed to open a required file";
			break;
		case TD_FLATROUT_NO_CONVERGENCE:
			msg = "Recursion on flat routing failed - most likely due to incorrect input fdr file";
			break;
		case TD_Fortran_Allocate_Error:
			msg = "Unable to allocate memory needed for channel network.";
			break;
		default:
			msg.Format("Unrecognized error number: %i",errorNumber);
	}

	*retval = msg.AllocSysString();
	return S_OK;
}


STDMETHODIMP CTauDEM::GridConvert(BSTR ipFile, BSTR opFile, int ipdataformat, int opdataformat, int opfiletype, long *result)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	USES_CONVERSION;//needed to convert from BSTR to Char* or CString
	*result = gridconvert(OLE2A(ipFile),OLE2A(opFile),ipdataformat,opdataformat,opfiletype);
	 return S_OK;

}

STDMETHODIMP CTauDEM::CheckDatatype(BSTR ipFile, int *datatype)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	USES_CONVERSION;//needed to convert from BSTR to Char* or CString
	*datatype=checkdatatype(OLE2A(ipFile));
	return S_OK;
}

//////////////////////////////////////////
STDMETHODIMP CTauDEM::gridExists(BSTR ipfile, long *result)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	USES_CONVERSION;
	*result=gridexists(OLE2A(ipfile));
	return S_OK;
}

STDMETHODIMP CTauDEM::gridDelete(BSTR ipfile, long *result)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	USES_CONVERSION;
	*result=griddelete(OLE2A(ipfile));

	return S_OK;
}

STDMETHODIMP CTauDEM::gridRename(BSTR ipfile, BSTR opfile, long *result)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	USES_CONVERSION;
	*result=gridrename(OLE2A(ipfile),OLE2A(opfile));

	return S_OK;
}
STDMETHODIMP CTauDEM::CreateGrid(BSTR demfile, BSTR opgridfile, int gridtype,int cellvalue, long *err)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	USES_CONVERSION;
	*err = creategrid(OLE2A(demfile),OLE2A(opgridfile),gridtype,cellvalue);
	return S_OK;
}

STDMETHODIMP CTauDEM::SlopeD(BSTR pfile, BSTR felfile, BSTR slpdfile, double d, long *err)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	USES_CONVERSION;
	*err = sloped(OLE2A(pfile),OLE2A(felfile),OLE2A(slpdfile),d);
	return S_OK;
}

STDMETHODIMP CTauDEM::SubsetGrid(BSTR bigGrid, BSTR newGrid, double *newbndbox, long *result)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here
	USES_CONVERSION;
	*result = subsetgrid(OLE2A(bigGrid),OLE2A(newGrid),newbndbox);
	return S_OK;
}

STDMETHODIMP CTauDEM::OutletsToSrc(BSTR pfile, BSTR ad8file, BSTR srcfile, long *xnode, long *ynode, int nxy, int max_dist, long *ismoved,long *dist_moved, long *result)
{
	//AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here
	USES_CONVERSION;
	*result = outletstosrc(OLE2A( pfile), OLE2A( srcfile), OLE2A( ad8file), 
					xnode, ynode, nxy,  max_dist, ismoved,dist_moved);
	return S_OK;
}

STDMETHODIMP CTauDEM::GridStat(BSTR grdname, BSTR iggrdname, long ind, double *statlist, long *result)
{
	//AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here
	USES_CONVERSION;
	*result = gridstat(OLE2A(grdname),OLE2A(iggrdname),ind,statlist);

	return S_OK;
}


STDMETHODIMP CTauDEM::DinfDistToStream(BSTR angfile, BSTR wfile, BSTR srcfile, BSTR dtsfile, int method, int useweight, int concheck, long *result)
{
	//AFX_MANAGE_STATE(AfxGetStaticModuleState())

	USES_CONVERSION;

	*result= disttostreamgrd(OLE2A(angfile), OLE2A(wfile), OLE2A(srcfile), OLE2A(dtsfile), method, useweight, concheck);

	return S_OK;
}


STDMETHODIMP CTauDEM::DinfRiseToRidge(BSTR angfile, BSTR felfile, BSTR rtrfile, int method, int concheck, float thresh, long *result)
{
	//AFX_MANAGE_STATE(AfxGetStaticModuleState())

	USES_CONVERSION;

	*result= risetoridgegrd(OLE2A(angfile), OLE2A(felfile), OLE2A(rtrfile), method, concheck, thresh);

	return S_OK;
}


STDMETHODIMP CTauDEM::DinfDropToStream(BSTR angfile, BSTR felfile, BSTR srcfile, BSTR vsfile, int method, long *result)
{
	//AFX_MANAGE_STATE(AfxGetStaticModuleState())

	USES_CONVERSION;

	*result= droptostreamgrd(OLE2A(angfile), OLE2A(felfile), OLE2A(srcfile), OLE2A(vsfile), method);

	return S_OK;
}


STDMETHODIMP CTauDEM::DinfAvalancheRunout(BSTR angfile, BSTR felfile, BSTR assfile, BSTR rzfile, BSTR dmfile, float thresh, float alpha, int path, long *result)
{
	//AFX_MANAGE_STATE(AfxGetStaticModuleState())

	USES_CONVERSION;

	*result= avalancherunoutgrd(OLE2A(angfile), OLE2A(felfile), OLE2A(assfile), OLE2A(rzfile), OLE2A(dmfile), thresh, alpha, path);

	return S_OK;
}

