// TauDEM.h : Declaration of the CTauDEM

#ifndef __TAUDEM_H_
#define __TAUDEM_H_

#include "resource.h"       // main symbols
#include "tardemlib.h"
//#include "grdapi.h"

/////////////////////////////////////////////////////////////////////////////
// CTauDEM
class ATL_NO_VTABLE CTauDEM : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CTauDEM, &CLSID_TauDEM>,
	public IDispatchImpl<ITauDEM, &IID_ITauDEM, &LIBID_TKTAUDEMLib>
{
public:
	STDMETHOD(DinfRiseToRidge)(BSTR angfile, BSTR felfile, BSTR rtrfile, int method, int concheck, float thresh, long *result);
	STDMETHOD(DinfDistToStream)(/*[in]*/ BSTR angfile, /*[in]*/ BSTR wfile, /*[in]*/ BSTR srcfile, /*[in]*/ BSTR dtsfile, /*[in]*/ int method, /*[in]*/ int useweight, /*[in]*/ int concheck, /*[out,retval]*/ long *result);
	STDMETHOD(DinfDropToStream)(BSTR angfile, BSTR felfile, BSTR srcfile, BSTR vsfile, int method, long *result);
	STDMETHOD(DinfAvalancheRunout)(BSTR angfile, BSTR felfile, BSTR assfile, BSTR rzfile, BSTR dmfile, float thresh, float alpha, int path, long *result);
	STDMETHOD(GridStat)(/*[in]*/BSTR grdname,/*[in]*/ BSTR iggrdname,/*[in]*/long ind, /*[in]*/ double *statlist,/*[out,retval]*/long *result);
	STDMETHOD(SlopeD)(BSTR pfile,BSTR felfile,BSTR slpdfile, double d,long *err);
	STDMETHOD(gridRename)(BSTR ipfile,BSTR opfile,long *result);
	STDMETHOD(gridDelete)(BSTR ipfile,long *result);
	STDMETHOD(gridExists)(BSTR ipfile,long *result);
	STDMETHOD(CreateGrid)(BSTR demfile, BSTR opgridfile, int gridtype,int cellvalue, long *err);
	STDMETHOD(CheckDatatype)(BSTR ipFile,int *datatype);
	STDMETHOD(GridConvert)(BSTR ipFile,BSTR opFile,int ipdataformat,int opdataformat,int opfiletype,long *result);
	CTauDEM()
	{
		GlobalCallback = NULL;
	}
	~CTauDEM()
	{
		if (GlobalCallback)
			GlobalCallback->Release();
	}

DECLARE_REGISTRY_RESOURCEID(IDR_TAUDEM)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CTauDEM)
	COM_INTERFACE_ENTRY(ITauDEM)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

	STDMETHOD(get_Callback)(/*[out, retval]*/ ItkCallback * *pVal);
	STDMETHOD(put_Callback)(/*[in]*/ ItkCallback * newVal);
	STDMETHOD(TlAccum)(/*[in]*/BSTR pfile, /*[in]*/BSTR wfile, /*[in]*/BSTR tcfile, /*[in]*/BSTR tlafile, /*[in]*/BSTR depfile, /*[in]*/BSTR cfile, /*[in]*/BSTR coutfile, /*[in]*/double *x, /*[in]*/double *y, /*[in]*/long nxy,   /*[in]*/long usec, /*[in]*/long contcheck, /*[out,retval]*/long *result);
	STDMETHOD(DsAccum)(/*[in]*/BSTR angfile, /*[in]*/BSTR wgfile, /*[in]*/BSTR depfile, /*[in]*/BSTR maxfile, /*[in]*/long touch, /*[in]*/float wgval, /*[out, retval]*/long *result);
	STDMETHOD(AreadinfDecay)(/*[in]*/BSTR angfile, /*[in]*/BSTR adecfile, /*[in]*/BSTR dmfile, /*[in]*/double *x, /*[in]*/double *y, /*[in]*/long nxy, /*[in]*/BSTR wfile, /*[in]*/long usew, /*[in]*/long contcheck, /*[out,retval]*/long *result);
	STDMETHOD(Distance)(/*[in]*/ BSTR pfile, /*[in]*/ BSTR srcfile, /*[in]*/ BSTR distfile, /*[in]*/ int thresh, /*[in]*/ int diskbasedflag,/*[out, retval]*/ long *result);
	STDMETHOD(Atanb)(/*[in]*/ BSTR slopefile, /*[in]*/ BSTR areafile, /*[in]*/ BSTR atanbfile, /*[in]*/ int diskbasedflag,/*[out, retval]*/ long *ans);
	STDMETHOD(WatershedToPolygon)(/*[in]*/BSTR WGridFile,/*[in]*/BSTR PGridFile, /*[in]*/BSTR ShapefileName,/*[out,retval]*/long *result);
	STDMETHOD(StreamToGrid)(/*[in]*/ BSTR Shapefilename,/*[in]*/ BSTR Gridfilename, /*[in]*/BSTR TemplateDEMfile, /*[out,retval]*/BOOL * result );
	STDMETHOD(Dropan)(/*[in]*/ BSTR areafile, /*[in]*/ BSTR slopefile, /*[in]*/ BSTR plenfile, /*[in]*/ BSTR dirfile, /*[in]*/ BSTR srcfile, /*[in]*/ BSTR elevfile, /*[in]*/ BSTR gordfile, /*[in]*/ BSTR scafile, /*[in]*/ BSTR fdrfile, /*[in]*/ int method, /*[in]*/ float *p, /*[in]*/ int nxy, /*[in]*/ double *x, /*[in]*/ double *y, /*[in]*/ int contcheck, /*[in]*/ int nthresh, /*[in]*/ int *thresholds, /*[out]*/ int *nfirstorder, /*[out]*/ int *nhigherorder, /*[out]*/ float *sumfirstorder, /*[out]*/ float *sumhigherorder, /*[out]*/ float *sumfirstordersquared, /*[out]*/ float *sumhigherordersquared, /*[out]*/ float *ddens, /*[in]*/ long masksca, /*[out, retval]*/ long *result);
	STDMETHOD(Subbasinsetup)(/*[in]*/ BSTR pfile, /*[in]*/ BSTR wfile, /*[in]*/ BSTR treefile, /*[in]*/ BSTR coordfile, /*[in]*/ BSTR shapefile, /*[in]*/ int ordert, /*[in]*/ int subbno, /*[out, retval]*/ long *result);
	STDMETHOD(Netsetup)(/*[in]*/ BSTR fnprefix, /*[in]*/ BSTR pfile, /*[in]*/ BSTR srcfile, /*[in]*/ BSTR ordfile, /*[in]*/ BSTR ad8file, /*[in]*/ BSTR felfile, /*[in]*/ BSTR treefile, /*[in]*/ BSTR coordfile, /*[in]*/ double *xnode, /*[in]*/ double *ynode, /*[in]*/ int nxy, /*[in]*/ long usetrace, /*[in]*/ long *idnodes, /*[out, retval]*/ long *result);
	STDMETHOD(Sourcedef)(/*[in]*/ BSTR ad8file, /*[in]*/ BSTR slpfile, /*[in]*/ BSTR plenfile, /*[in]*/ BSTR pfile, /*[in]*/ BSTR srcfile, /*[in]*/ BSTR elevfile, /*[in]*/ BSTR gordfile, /*[in]*/ BSTR scafile, /*[in]*/ BSTR fdrnfile, /*[in]*/ int method, /*[in]*/ float *p, /*[in]*/ int nxy, /*[in]*/ double *x, /*[in]*/ double *y, /*[in]*/ int contcheck, /*[in]*/ int masksca, /*[out, retval]*/ long *result);
	STDMETHOD(Gridnet)(/*[in]*/ BSTR pfile, /*[in]*/ BSTR plenfile, /*[in]*/ BSTR tlenfile, /*[in]*/ BSTR gordfile, /*[in]*/ BSTR maskfile, /*[in]*/ double *x, /*[in]*/ double *y,/*[in]*/long nxy, /*[in]*/ long UseMaskFile, /*[in]*/ long UseOutlets, /*[in]*/ long thresh, /*[out, retval]*/long *result);
	STDMETHOD(Areadinf)(/*[in]*/ BSTR angfile, /*[in]*/ BSTR scafile, /*[in]*/ double *x, /*[in]*/ double *y,/*[in]*/ long nxy, /*[in]*/ int doall, /*[in]*/ BSTR wfile, /*[in]*/ int usew, /*[in]*/ int contcheck, /*[out, retval]*/ long *result);
	STDMETHOD(Aread8)(/*[in]*/ BSTR pfile, /*[in]*/ BSTR ad8file, /*[in]*/ double * x, /*[in]*/ double * y,/*[in]*/long nxy, /*[in]*/ long doall, /*[in]*/ BSTR wfile, /*[in]*/ long usew, /*[in]*/ long contcheck,/*[out, retval]*/ long *result);
	STDMETHOD(Dinf)(/*[in]*/ BSTR felfile, /*[in]*/ BSTR angfile, /*[in]*/ BSTR slopefile, /*[in]*/  BSTR fdrnfile, /*[in]*/ short useflowfile, /*[in,optional, defaultvalue(TRUE)]*/ VARIANT_BOOL InRam, /*[out, retval]*/ long *result);
	STDMETHOD(D8)(/*[in]*/ BSTR felfile, /*[in]*/ BSTR pfile, /*[in]*/ BSTR sd8file, /*[in]*/ BSTR fdrnfile,  /*[in]*/ short useflowfile, /*[in,optional, defaultvalue(TRUE)]*/ VARIANT_BOOL InRam, /*[out, retval]*/ long *result);
	STDMETHOD(Flood)(/*[in]*/ BSTR demfile, /*[in]*/ BSTR fillfile, /*[in]*/ BSTR fdrfile, /*[in]*/ BSTR fdrnfile, /*[in]*/ short useflowfile, /*[in,optional, defaultvalue(TRUE)]*/ VARIANT_BOOL InRam, /*[out, retval]*/ long *result);
	STDMETHOD(Dependence)(/*[in]*/BSTR anglefile, /*[in]*/BSTR disturbgridfile,/*[in]*/BSTR depfile, /*[out,retval]*/long *result);
	STDMETHOD(SLLAccum)(/*[in]*/BSTR pfile,/*[in]*/BSTR outputFile, /*[in]*/BSTR decayMultFile, /*[in]*/double *x,/*[in]*/double *y, /*[in]*/long nxy,/*[in]*/BSTR wfile,/*[in]*/BSTR indicatorFile,/*[in]*/ long contcheck,/*[in]*/float cSol, /*[out,retval]*/long * result);
	STDMETHOD(getErrorMsg)(/*[in]*/long errorNumber,/*[out,retval]*/BSTR * retval);
	STDMETHOD(OutletsToSrc)(/*[in]*/ BSTR pfile, /*[in]*/ BSTR ad8file, /*[in]*/ BSTR srcfile, /*[in]*/ long *xnode, /*[in]*/ long *ynode, /*[in]*/ int nxy,/*[in]*/int max_dist,/*[in]*/long *ismoved,  /*[in]*/long *dist_moved, /*[out,retval]*/ long *result);
	STDMETHOD(SubsetGrid)( /*[in]*/ BSTR bigGrid, /*[in]*/ BSTR newGrid, /*[in]*/ double *newbndbox,/*[out,retval]*/ long *result);

	// ITauDEM
private:
	ItkCallback * GlobalCallback;
};

#endif //__TAUDEM_H_
