#include "TDErrorCodes.h"
#include "gridio.h"

extern int *d1, *d2;
//***************************************************************************************
//  Kiran added this 1/22/04
int outletstosrc(char *pfile, char *srcfile,char *ad8file, long *xnode, long *ynode, int nxy, int max_dist,long *ismoved,  long *dist_moved)
{
	int itresh, **area,nyn,nxn;
	int err = TD_NO_ERROR;
	short **dir;
	int usetrace =1;
	sgrid sdirgrid;
	int ftype;
	/* define directions */
	d1[1]=0; d1[2]= -1; d1[3]= -1; d1[4]= -1; d1[5]=0; d1[6]=1; d1[7]=1; d1[8]=1;
	d2[1]=1; d2[2]=1; d2[3]=0; d2[4]= -1; d2[5]= -1; d2[6]= -1; d2[7]=0; d2[8]=1;

//	FILE *fp;
	
	itresh=1;  // Thresholding to 1 done in source
	/*    err=gridread(pfile,&dirg,&filetype);


		 
	if ()
	{
		//sprintf(errmessage,"Failed to open grid file %s",pfile);
		 //AfxMessageBox(errmessage);
		return err;
	}read dirfile   */
	
	//err=gridread(pfile,(void ***)&dir,RPSHRDTYPE,&nx,&ny,&dx,&dy,
	//	bndbox,&csize,&ndv,&filetype);
	//if ( sDirGrid.open(pfile) )
	err=gridread(pfile,&sdirgrid,&ftype);
	if(err != TD_NO_ERROR){
		return err;
	}
		
	//else 
	//	err=TD_FAILED_GRID_OPEN;
	
	//if (err != TD_NO_ERROR)
	//	return err;
	
	//sDirHeader = sDirGrid.getHeader();
	
	int nx =sdirgrid.head.nx;// sDirHeader.getNumberCols();
	int ny = sdirgrid.head.ny;
	double dx = sdirgrid.head.dx;
	double dy = sdirgrid.head.dy;
	double csize = dx;
	short ndv = sdirgrid.nodata;
	double bndbox[4];
	for(int i=0;i<4;i++)bndbox[i]=sdirgrid.head.bndbox[i];

	//bndbox[0] = sDirHeader.getXllcenter() - csize/2;
	//bndbox[1] = sDirHeader.getYllcenter() - csize/2;
	//bndbox[2] = bndbox[0] + (nx*dx);
	//bndbox[3] = bndbox[1] + (ny*dy);
	
	//copy data into dir array for use in fortran code
	if((dir = (short**) matalloc(nx,ny, RPSHRDTYPE)) == NULL)
	{
		err=TD_FAILED_MEMORY_ALLOC;
		//  printf("Could not allocate memory for src\n");
		//goto ERROR1;
		return err;
	}  
	//allocate memory to ismoved and dist_moved
	//ismoved = new int [nxy];
	//dist_moved = new int [nxy];

	for (int curRow = 0; curRow < ny; curRow++){
		for (int curCol = 0; curCol < nx; curCol++)
			dir[curCol][curRow] = sdirgrid.d[curCol][curRow];
	}
	
	
	/*    read srcfile   */
	igrid iareagrid;
			
	if (gridread(srcfile,&iareagrid,&ftype)==0)// lAreaGrid.open(srcfile) )
		err= TD_NO_ERROR;
	else
		err=TD_FAILED_GRID_OPEN;
	
	if (err != TD_NO_ERROR)
		return err;
	
	//lAreaHeader = lAreaGrid.getHeader();
	
	nxn =iareagrid.head.nx; //lAreaHeader.getNumberCols();
	nyn = iareagrid.head.ny;//lAreaHeader.getNumberRows();
	
	//copy area data into area array for use in fortran code
	
	if((area = (int**) matalloc(nxn,nyn, RPINTDTYPE)) == NULL)
	{
		err=TD_FAILED_MEMORY_ALLOC;
		//  printf("Could not allocate memory for src\n");
		//goto ERROR1;
		return err;
	}  
	for (curRow = 0; curRow < ny; curRow++){
		for (int curCol = 0; curCol < nx; curCol++)
			area[curCol][curRow] =iareagrid.d[curCol][curRow];
	}
	
	
	if(nxn != nx || nyn != ny)
	{
		//	   printf("Incompatible grid sizes\n");
		//	   exit(0);
		return 1;
	}
	
	
	//  check for source values >= threshold else fortran crashes
	int   n=0,j;
	for(i=0; i<ny; i++){
		for(j=0; j<nx; j++)
			if(area[j][i] >=itresh)n=n+1;
	}
	if(n <= 0)
	{
		err=TD_CHANNEL_NETWORK_MISMATCH;
	}
	else
	{
		short *inodes;
		short *jnodes;

//  If there are outlets set up inodes, jnodes arrays
		if(nxy > 0){
			inodes = new short [nxy];
			jnodes = new short [nxy];
		}else
		{	
			inodes = new short [1];
			jnodes = new short [1];
		}

		for(int inode = 0; inode<nxy; inode++)
		{  
			jnodes[inode]= (short)floor((xnode[inode]-bndbox[0])/csize);  
			inodes[inode]= (short)floor((bndbox[3]-ynode[inode])/csize);
			int loopcount=0; //Kiran declared before the loop
//   Trace to raster if necessary but only for nodes that are inside the domain
			if(usetrace == 1  && inodes[inode]>0 && inodes[inode] < ny-1 && 
				jnodes[inode] > 0 && jnodes[inode] < nx-1) 
			{
				if(area[jnodes[inode]][inodes[inode]] < itresh)  // Not on grid
				{
					//   Next downslope 
					short dirn=dir[jnodes[inode]][inodes[inode]];
					int nexti=inodes[inode]+d1[dirn];
					int nextj=jnodes[inode]+d2[dirn];
					loopcount = 0;
					while(nexti>0 && nexti < ny-1 && nextj > 0 && nextj < nx-1 && area[jnodes[inode]][inodes[inode]] < itresh)
					{
						inodes[inode]=nexti;
						jnodes[inode]=nextj;
						dirn = dir[jnodes[inode]][inodes[inode]];
						if(dirn < 1 || dirn > 8)break;   // Here have gone out of grid so terminate trace downwards
						nexti=nexti+d1[dirn];
						nextj=nextj+d2[dirn];
						loopcount=loopcount+1;
						if(loopcount > nx && loopcount > ny && loopcount > max_dist)break;   // Here possible infinite loop so terminate trace downwards
					}
				}
			}
			if (loopcount < max_dist){
				xnode[inode] = (long)(jnodes[inode]*csize + bndbox[0]+csize/2.);
				ynode[inode] = (long)(bndbox[3]-(inodes[inode]*csize)-csize/2.);
				dist_moved[inode]=loopcount;//Kiran..to keep track of how many cells each outlet has moved
				ismoved[inode] = 1;
			}
			else{
				dist_moved[inode]=max_dist;
				ismoved[inode] = 0;
				
			}
			
		}
		free(dir[0]); free(dir);
		free(sdirgrid.d[0]); free(sdirgrid.d);
		free(area[0]); free(area);
		free(iareagrid.d[0]); free(iareagrid.d);
	}
		return err;

}
//XXXXXXXXXXXXXXXXXXXXXX converted FORTRAN tardemflib.f ..Kiran XXXXXXXXXXXXXXXXXXXXXXXXX
//These functions are required by the Netex function
//strt(), isnode_c() and isnode2()
bool strt(int i,int j,int **area,short **dir, long nx, long ny, int igx, int igy,int itresh){

int ind,jnd,in,jn;
//strt = true;
 /* define directions */
 d1[1]=0; d1[2]= -1; d1[3]= -1; d1[4]= -1; d1[5]=0; d1[6]=1; d1[7]=1; d1[8]=1;
 d2[1]=1; d2[2]=1; d2[3]=0; d2[4]= -1; d2[5]= -1; d2[6]= -1; d2[7]=0; d2[8]=1;

if (area[j][i] < itresh){
		if(area[j][i] <= 0){
			dir[j][i] = 0; // ZERO DIRECTIONS OUTSIDE AREA
			}
		return false;
}
else{ //check upstream pixels
	int k;
	for (k=1; k<= 8 ;k++)
	{
		in=i+d1[k];    // NEIGHBOUR PIXEL
        jn=j+d2[k];       
        if(dir[jn][in] > 0)
		{
		  ind=in+d1[dir[jn][in]] ;  // PIXEL DOWNSTREAM FROM NEIGHBOUR
		  jnd = jn + d2[dir[jn][in]];
		  if(ind == i && jnd == j)
		  { //NEIGHBOUR DRAINS INTO (I,J)
			  if(area[jn][in] >= itresh) return false;
		  }
		}
	}
	in=i+d1[dir[j][i]];
	jn=j+d2[dir[j][i]];
	if(area[jn][in] < itresh)return false;
}
return true;
}
bool isnode_c(int mnext, int mag, int i , int j , short *inodes, short *jnodes, int nnodes){
	int k;
	for (k= 0; k < nnodes;k++){
		if( inodes[k] == i && jnodes[k] == j ){
			if( mnext != mag) return false;
			return true;
		}
	}
	return false; 
}
//This function is required by the Netex function
bool isnode2(int i , int j , short *inodes, short *jnodes, int nnodes,int &nodeno){
	int k;
	for (k= 0; k < nnodes ;k++){
		if( inodes[k]  == i && jnodes[k] == j ){
			nodeno=k;//for return to use in indexing
			return true;
		}
	}
	return false; 
}
//XXXXXXXXXXXXXXXXXXXXXXXX converted FORTRAN tardemflib.f XXXXXXXXXXXXXXXXXXXXXXXXX

int Netex_c(short **dir, int **area, char *treefile, char *coordfile, char *ordfile, int nx, int ny, int itresh,
			 int& icr, int& icend, double dx, double dy, double bndbox, double csize, int iftype, 
			 short *inodes, short *jnodes, int nnodes, long *idnodes){

/*	NETEX(dir[0],area[0],treefile,strlen(treefile),coordfile,strlen(coordfile),
			ordfile,strlen(ordfile),&nx,&ny,&itresh,&icr,&icend,&fdx,&fdy,bndbox,&csize,
			&filetype,&err,inodes,jnodes,&nxy,idnodes);  */
	int ipoint[7],iordup[7];
	
	int ishrdt=1, iintdt=2,ifltdt=3;//these are declared as paramters in FORTRAN
	

	//Read input
	int igy=ny,i,j;
	int igx=nx;
	int err=0;
	int n=0;
	int nmax=0;
	bool k=0;
	/* Count all start pixels */
	for( i= 0; i< ny;i++)
	{
		for(j= 0; j< nx;j++)
		{
			if(strt(i,j,area,dir,nx,ny,igx,igy,itresh))
				n=n+1;
		}
	}
	nmax=n;
	int mnl=2*n+1+nnodes;
//  Allocate memory
	int *nextl = new int[mnl+1];
	int *prevL1=new int[mnl+1];
	int	*prevL2=new int[mnl+1];
	int *ist=new int[nmax+1];
	int *jst=new int[nmax+1];
	int *iord=new int[mnl+1];
	int	*istart=new int[mnl+1];
	int *jstart=new int[mnl+1];
	int *iend=new int[mnl+1];
	int *jend=new int[mnl+1];
	int *mag=new int[mnl+1];
	n=0;
	for( i= 0; i< ny;i++)
	{
		for(j= 0; j< nx;j++)
		{
			if(strt(i,j,area,dir,nx,ny,igx,igy,itresh))
			{    
				n=n+1;
				ist[n]=i;
				jst[n]=j;
			}
		}
	}
	if ( n > nmax)return(2);
/*Zero area array*/
	for(i= 0; i< ny;i++){
		for(j= 0; j< nx;j++){
			area[j][i]=0;
		}
	}

	/*Trace streams downwards adding 1 to magnitude of each pixel.  
	(Magnitude stored in area array)*/
	int is,inext,jnext;
	for(is=1; is<=n; is++){           //This was DO 3
		i =ist[is];
		j=jst[is];
		while(dir[j][i] > 0){
			area[j][i]=area[j][i]+1;
			inext=i+d1[dir[j][i]];
			jnext=j+d2[dir[j][i]];
			i=inext;
			j=jnext;
		}

	}
//Identify links by different magnitude
	int ilink=1;
	for(is = 1;is<=n;is++){     
		istart[ilink]=ist[is];
		jstart[ilink]=jst[is];
		//initialize pointers
		prevL1[ilink]=0;
		prevL2[ilink]=0;
		i=ist[is];
		j=jst[is];
		mag[ilink]=area[j][i];
		iord[ilink]= 1;
		int mnext;
START6: inext=i+d1[abs(dir[j][i])];
		jnext=j+d2[abs(dir[j][i])];
		//check for the end
		int intemp,jntemp;
		if(dir[jnext][inext] == 0){ //end of path
			iend[ilink]=i;
			jend[ilink]=j;
			nextl[ilink]=-1;
			if(is < n)
				ilink=ilink+1; //if not last on list increment link counter
		}
		else{
			mnext=area[jnext][inext];
			i=inext;
			j=jnext;
			iend[ilink]=i;
			jend[ilink]=j;
			//modes allow insertion of nodes DGT 7/17/02 as commented in the original FORTRAN code
			if(isnode_c(mnext,mag[ilink],i,j,inodes,jnodes,nnodes)){
				//check here that this is not the end of a path because then it will be a node anyway
				intemp=i+d1[abs(dir[j][i])];
				jntemp=j+d2[abs(dir[j][i])];
				if(dir[jntemp][intemp] != 0){
					ilink=ilink+1;
					istart[ilink]=i;
					jstart[ilink]=j;
					prevL1[ilink]=ilink-1;
					prevL2[ilink]=0;
					nextl[ilink-1]=ilink;
					mag[ilink]=mag[ilink-1];
					iord[ilink]=iord[ilink-1];
					iend[ilink]=i;
					jend[ilink]=j;
				}
			}
			//end mods to allow insertion of nodes DGT
			if(mnext == mag[ilink])goto START6;
			//continue here for new link
			//check if junction already reached (flagged by negative direction)
			if(dir[j][i] < 0){
				//check if all links converging are have been done by summing magnitude
				int msum=0;
				int iordm=0;
				int iconv=0, il;
				for (il=1;il<=ilink;il++){    //  This was DO 7
					if(iend[il] == i && jend[il] == j){
						iconv=iconv+1;//counter of number of links that converge
						ipoint[iconv]=il;
						iordup[iconv]=iord[il];
						msum=msum+mag[il];
					}
				}
				if(msum == mnext){ //yes all links have been processed
					//sort irdup, ipoint into descending stream order
					for(int ic=1;ic <= iconv-1;ic++){     // These were DO 11
						for(int iic=ic+1;iic <=iconv;iic++){
							if(iordup[iic] > iordup[ic]){
								int itemp=iord[iic];
								iordup[iic]=iordup[ic];
								iordup[ic]=itemp;
								itemp=ipoint[iic];
								ipoint[iic]=ipoint[ic];
								ipoint[ic]=itemp;
							}
						}
					}
					for(ic=1;ic <= iconv-1;ic++){   //DO 17
						ilink=ilink+1;
						istart[ilink]=i;
						jstart[ilink]=j;
						prevL1[ilink]=ipoint[ic];
						prevL2[ilink]=ipoint[ic+1];
						nextl[ipoint[ic]]=ilink;
						nextl[ipoint[ic+1]]=ilink;
						mag[ilink]=mag[prevL1[ilink]]+mag[prevL2[ilink]];
//						iord[ilink]=max(iordup[0],iordup[1]+1);
						iord[ilink]= (iordup[1] >(iordup[2]+1))? iordup[1]:(iordup[2]+1);
						ipoint[ic+1]=ilink;
						iend[ilink]=i;
						jend[ilink]=j;
					}
					goto START6;
				}
				else{
					ilink=ilink+1;
				}
				
			}
			else{
				dir[j][i]=-dir[j][i];
				ilink=ilink+1;
			}
		}//end of path closure
		
	}
	FILE *fcoord,*ftree;
	fcoord=fopen(coordfile,"w");
	ftree=fopen(treefile,"w");
	//reinitialize area.  For output it will contain order
	for(i= 0; i<= ny-1;i++){
		for(j= 0; j<= nx-1;j++){
			area[j][i]=0;
		}
	}
	int icord=0,ics;
	int inodeid=0,nodeno;
	//write root link first
	for(int il=ilink;il<=ilink;il++){   // DO 10
		i=istart[il];
		j=jstart[il];
		ics=icord;
		while ((i != iend[il]) || (j != jend[il]) ){
			fprintf(fcoord,"%d %d\n",i+1,j+1);	fflush(fcoord);
//			area[j][i]=max(iord[il-1],area[j][i]);
			area[j][i]=(iord[il]>area[j][i])? iord[il]: area[j][i];
			icend=icord;
			icord=icord+1;
			inext=i+d1[abs(dir[j][i])];
			jnext=j+d2[abs(dir[j][i])];
			i=inext;
			j=jnext;
		}
		fprintf(fcoord,"%d %d\n",i+1,j+1);	fflush(fcoord);
//		area[j][i]=max(iord[il-1],area[j][i]);
		area[j][i]=(iord[il]>area[j][i])? iord[il]: area[j][i];
		icend=icord;
		icord=icord+1;

		inodeid=0;		//this will be the first one so will be the most downstream
		if(isnode2(iend[il],jend[il],inodes,jnodes,nnodes,nodeno)){
			if(idnodes[nodeno] >= 0){
				inodeid=idnodes[nodeno];
				idnodes[nodeno]=-1;//this logic to pick only the first one if there are multiple at a junction
			}
		}
		fprintf(ftree,"\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\n",0,ics,icend,-1,prevL1[il],prevL2[il],iord[il],inodeid);
		fflush(ftree);
	}
	icr=icord;
	//write reminder links
	for(il=1; il<=ilink-1;il++){
		i=istart[il];
		j=jstart[il];
		ics=icord;
		
		while(i != iend[il] || j != jend[il])
		{
			fprintf(fcoord,"%d %d\n",i+1,j+1);	fflush(fcoord);
//			area[j][i]=max(iord[il],area[j][i]);
			area[j][i]=(iord[il]>area[j][i])? iord[il] : area[j][i];
			icend=icord;
			icord=icord+1;
			inext=i+d1[abs(dir[j][i])];
			jnext=j+d2[abs(dir[j][i])];
			i=inext;
			j=jnext;
		}
		fprintf(fcoord,"%d %d\n",i+1,j+1);	fflush(fcoord);
		area[j][i]=(iord[il]>area[j][i])? iord[il] : area[j][i];
		icend=icord;
		icord=icord+1;
		if(nextl[il] == ilink)nextl[il]=0;
		inodeid=-1;
		if(nextl[il] < 0)inodeid=0;//this is a most downstream link so flagged by inodeid=0
		if(isnode2(iend[il],jend[il],inodes,jnodes,nnodes,nodeno)){
			if(idnodes[nodeno] >= 0){
				inodeid=idnodes[nodeno];
				idnodes[nodeno]=-1;//this logic to pick only the first one if there are multiple at a junction
			}
		}
		fprintf(ftree,"\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\n",il,ics,icend,nextl[il],prevL1[il],prevL2[il],iord[il],inodeid);
		fflush(ftree);
	}
	fclose(ftree);
	fclose(fcoord);
	return(err);
}
//XXXXXXXXXXXXXXXXXXXXXXXX converted FORTRAN tardemflib.f XXXXXXXXXXXXXXXXXXXXXXXXX

void Netprop_c(short **dir, int **area, float **elev, char *coordfile, int& icr, 
			   int& icmax,double& dx, double& dy,int& nx, int& ny, 
			   double bndbox, double& csize,int& err){	

/*NETPROP(dir[0],area[0],elev[0],coordfile,strlen(coordfile),&icr,&icend,&fdx,
			&fdy,&nx,&ny,bndbox,&csize,&err); 
			
*/	/*		
	int MNL = 5000;//This is hard coded in FORTRAN for memory allocation for tha arrays and may be changed to dynamic allocation
	char *pointfile, *areafile;
	int *nextl = new int[MNL];
	int *prevL1=new int[MNL];
	int	*prevL2=new int[MNL];
	int ipoint[7],iordup[7],d1[8],d2[8];
	int *ist=new int[(MNL+1)/2];
	int *jst=new int[(MNL+1)/2];
	int *iord=new int[MNL];
	int	*istart=new int[MNL];
	int *jstart=new int[MNL];
	int *iend=new int[MNL];
	int *jend=new int[MNL];
	int *mag=new int[MNL];
	*/

}